/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "FontManager.hpp"

FontManager *FontManager::singletonObject = 0;

FontManager::FontManager()
{
    
}

FontManager *FontManager::getInstance()
{
    if (!singletonObject)
        singletonObject = new FontManager();
    
    return singletonObject;
}

sf::Font *FontManager::getFont(const std::string &fontPath)
{
    if (!isFontLoaded(fontPath))
        loadFont(fontPath);
    
    return &m_fontsList[fontPath];
}

void FontManager::loadFont(const std::string &fontPath)
{   
    sf::Font loadedFont;
    loadedFont.LoadFromFile(fontPath);
    
    m_fontsList[fontPath] = loadedFont;
}

bool FontManager::isFontLoaded(const std::string &fontPath)
{
    std::map<std::string, sf::Font>::iterator it;
    it = m_fontsList.find(fontPath);
    
    if (it != m_fontsList.end())
        return true;
    
    return false;
}